class Verarbeitungseinheit(object):
    def __init__(self, r, w):
        self.roboter = r
        self.welt = w



    def verarbeiteAnweisung(self, anw):
        if anw == "schritt":
            self.roboter.schritt()
        elif anw == "links":
            self.roboter.links()
        elif anw == "rechts":
            self.roboter.rechts()
        elif anw == "markeSetzen":
            self.roboter.markeSetzen()
        elif anw == "markeLoeschen":
            self.roboter.markeLoeschen()
        elif anw == "ziegelHinlegen":
            self.roboter.ziegelHinlegen()
        elif anw == "ziegelAufheben":
            self.roboter.ziegelAufheben()

    def verarbeiteBedingung(self, bed):
        if bed == "nichtVorZiegel":
            return self.roboter.nichtVorZiegel()
        elif bed == "nichtVorWand":
            return self.roboter.nichtVorWand()
        # ???





#----------------------------------------------------------------



class Interpreter(object):
    def __init__(self, v):
        self.programm = None
        self.verarbeitungseinheit = v


    def setProgramm(self, p):
        self.programm = p
        #self.programm = [["h"], ["s"], ["r"], ["s"], ["s"]]
        #self.programm = ["sq", ["h"], ["s"], ["wh", "nz", ["sq", ["wh", "nw", ["sq", ["s"]]], ["l"]]]]
        #self.programm = [["h"], ["s"], ["wh", "nz", [["wh", "nw", [["s"]]], ["l"]]]]

    def getProgramm(self):
        return self.programm



    def anweisungAusfuehren(self):
        #print(self.programm)
        if self.programm != []:
            anw = self.programm[0]
            if anw[0] == "s":
                self.verarbeitungseinheit.verarbeiteAnweisung("schritt")
                self.programm = self.programm[1:]
            elif anw[0] == "l":
                self.verarbeitungseinheit.verarbeiteAnweisung("links")
                self.programm = self.programm[1:]
            elif anw[0] == "r":
                self.verarbeitungseinheit.verarbeiteAnweisung("rechts")
                self.programm = self.programm[1:]
            elif anw[0] == "zh":
                self.verarbeitungseinheit.verarbeiteAnweisung("ziegelHinlegen")
                self.programm = self.programm[1:]
            elif anw[0] == "za":
                self.verarbeitungseinheit.verarbeiteAnweisung("ziegelAufheben")
                self.programm = self.programm[1:]
            elif anw[0] == "wh":
                self.programm = [anw[1]] + [anw[2]] + self.programm
            elif anw[0] == "nz":
                if self.verarbeitungseinheit.verarbeiteBedingung("nichtVorZiegel"):
                    self.programm = self.programm[1] + self.programm[2:]
                else:
                    self.programm = self.programm[3:]
            elif anw[0] == "nw":
                if self.verarbeitungseinheit.verarbeiteBedingung("nichtVorWand"):
                    self.programm = self.programm[1] + self.programm[2:]
                else:
                    self.programm = self.programm[3:]

#----------------------------------------------------------------------
